#include"getopt.h"

#include<stdio.h>
#include<stdarg.h>
#include<string.h>
#include<unistd.h>
#include<sys/syslog.h>
#include<fcntl.h>
#include<sys/stat.h>
#include<errno.h>
#include<sys/types.h>
#include<stdlib.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<arpa/inet.h>
#include<time.h>
#include<pwd.h>
#include<grp.h>
#include<signal.h>

#define MAXBUFFER 256
#define MAXMSG 1500
#define HASH(x, y) (x % y)
#define MAXHASH 1024
#define DEFAULT_PORT 514

#define LOOKUP(x,y) lookup[HASH(x,y)]
#define FDS(x,y) (lookup[HASH(x,y)]->fd)
#define ADDR_IP(x,y) (lookup[HASH(x,y)]->addr_ip)
#define FILENAME(x,y) (lookup[HASH(x,y)]->filename)

void ReloadConfig();
static void log(int, const char *, va_list);
void LogInfo(const char *, ...);
void LogError(const char *, ...);
int CloseFiles();
int OpenFiles();
int LoadIPs();
int CalculaNhash(int);
int get_gid(char *);
int get_uid(char *);
int InitSyslog();
int RunSyslog(int);
void usage(char *);
void init_daemon(char *, int);

struct ip_t {
	in_addr_t addr_ip;
	char *string_ip;
	char *filename;
	struct ip_t *next;
	int fd;
};

struct conf_t {
	char debug;
	char daemon;
	char *config_file;
	char *user;
	char *group;
	char *chroot;
	int port;
};
